#!/usr/bin/perl -w

# BLM to BlinkenLEDs Plus conversion script

foreach $file (@ARGV) {
	open (INPUT, $file) or print (STDERR "$file: $!\n");
	$linecnt = 0;
	$line = 0;
	$time = 0;
	@frame = ();
	print ("; $file\n");
	while (<INPUT>) {
		chomp ($_);
		$linecnt++;
		if ((length($_) == 0) || (substr ($_, 0, 1) eq "#")) {
			next;
		} elsif (substr ($_, 0, 1) eq "@") {
			$time = substr ($_, 1);
			chomp ($time);
			if ($line != 0) {
				print (STDERR "$file: frame too short ($linecnt)\n");
			}
			$line = 0;
			@frame = ();
		} else {
			if (length ($_) >= 18) {
				$frame[$line++] = $_;
			} else {
				print (STDERR "$file: line too short ($linecnt)\n");
			}
		}
		if ($line == 8) {
			if ($time == 0) {
				print (STDERR "$file: time is zero, using minimum value 10ms ($linecnt)\n");
				$time = 100;
			}
			if ($time % 10 != 0) {
				print (STDERR "$file: time is not a multiple of 10ms ($linecnt)\n");
			}
			printf (".db 0x%02x, 0x%02x", ($time / 10) % 0x100, $time / 10 / 0x100);
			for ($i = 0; $i < 18; $i++) {
				$byte = 0;
				for ($bit = 0; $bit <= 7; $bit++) {
					if (substr ($frame[$bit], $i, 1) ne "0") {
						$byte |= 1<<$bit;
					}
				}
				printf (", 0x%02x", $byte);
			}
			print ("\n");
			$line = 0;
			$time = 0;
			@frame = ();
		}
	}
	print ("\n");
	close (INPUT);
}
